// AMCIDrvr. c p p   :  Defines the class behaviors for the application
//

#include 	<afxwin.h>
#include	<conio.h>
#include	"AMCIDrvr.h"

#ifdef _DEBUG
  #undef	THIS_FILE
  static char BASED_CODE THIS_FILE[]  =  __FILE__;
#endif
//////////////////////////////////////////////////////////////////////////
//
// CrslvApp 

//////////////////////////////////////////////////////////////////////////
//
// CrslvApp  construction

CrslvApp::CrslvApp()
{
	//nothing special
}

//////////////////////////////////////////////////////////////////////////
//
// CrslvApp  initialization  

BOOL	CrslvApp::InitInstance()
{
	TRACE  ("Resolver Control Initializing \n");       
	return	TRUE;
}

int		CrslvApp::ExitInstance()
{
	TRACE	("Resolver Control Exiting \n");
	return	CWinApp::ExitInstance();
}
//////////////////////////////////////////////////////////////////////////
//
//	The Resolver Control Objects

CrslvApp	NEAR	RslvCtrl;
//////////////////////////////////////////////////////////////////////////
//
// public interface to Visual Basic

///////////////////////////////////////////////////////////////////////////////////////////////////
//
//   Interface Constants
 const short Trsmt = 0x8000;
 const short ClErr = 0xC000;
 #if multi
 const short SetTa = 0x8080;
 const short RspTm = 0x0800;
 #else
 const short SetTa = 0xA000;
 const short RspTm = 0x1000;
 #endif
 const short Prst4 = 0x8800;
 const short Prst3 = 0x8400;
 const short Prst2 = 0x8200;
 #if multi
 const short Prst1 = 0x8008;
 #else
 const short Prst1 = 0x8100;
 #endif
 const short SclF4 = 0x8080;
 const short PVal4 = 0x8040;
 const short SclF3 = 0x8020;
 const short PVal3 = 0x8010;
 const short SclF2 = 0x8008;
 const short PVal2 = 0x8004;
 #if multi
 const short SclF1 = 0x8010;
 const short PVal1 = 0x8020;
 #else
 const short SclF1 = 0x8002;
 const short PVal1 = 0x8001;
 #endif
 

 const short Acklg = 0x8000;
 const unsigned char Ack = 0x80;
 const short PCBEr = 0x4000;
 const short TrEr1 = 0x0400;
 const short TrEr2 = 0x0800;
 const short TrEr3 = 0x1000;
 const short TrEr4 = 0x2000;
 const short CmdEr = 0x0200;
 const short MsgIg = 0x0100;
 const short ScFE4 = 0x0080;
 const short ValE4 = 0x0040;
 const short ScFE3 = 0x0020;
 const short ValE3 = 0x0010;
 const short ScFE2 = 0x0008;
 const short ValE2 = 0x0004;
 const short ScFE1 = 0x0002;
 const short ValE1 = 0x0001;
                           
static short Input[9];
#if sim               
static short InpVals[9]={0,10,1,20,2,30,3,40,4};
static unsigned char OutVals[18];
#endif		//sim


void
CrslvApp::GetInp(short Adr,short Cnt){
	short i, Words;
	Words = Cnt*2+1;					//Position, Vel, Flags
#if multi
	for (i = 0;i < 6;i++){
#else	
	for (i = 0;i < Words;i++){
#endif
#if !sim 
			Input[i] = _inp(Adr);
			Input[i]+= 256*_inp(Adr+1);
#else
			Input[i] = InpVals[i];
#endif							// sim
			Adr	+=2;
			};
#if multi
			short flg= Input[0];
			Input[0] &= 0xFCCF;
			if (flg &0x10) 
				Input[0] |= 0x20;
			if  (flg & 0x20)
				Input[0] |= 0x10;							
			if (flg &  0x100) 
				Input[0] |= 0x200;
			if  (flg & 0x200)
				Input[0] |= 0x100;							
#endif
#if sim
			switch (OutVals[1]){
				case 0xC0:				//ClErr
					InpVals[0]= 0x0;
					break;
				case 0xA0:				//SetTa
					InpVals[0]= 0x4000;  //PCB err
					break;
				case 0x88:				//PRST4
					InpVals[0]= 0x0400;	//RSLV 4
					break;
				case 0x84:
					InpVals[0]= 0x0800;
					break;
				case 0x82:
					InpVals[0]= 0x1000;
					break;
				case 0x81:
					InpVals[0]= 0x2000;
					break;
				default:
					InpVals[0]= 0x2;
			}
					                            
			if (OutVals[1] & Ack)			
			  InpVals[0] = InpVals[0] | Acklg;
			else  
			  InpVals[0]=InpVals[0] & ~Acklg;	
#endif
}
    
    
extern "C" void FAR PASCAL _export 
SetScf1(short Adr, short ScF1){
	TRY
	{                                
#if	 !sim
	_outp (Adr+2,(unsigned char) ScF1);
	_outp (Adr+3,(unsigned char)(ScF1 >>8));
	_outp (Adr	,(unsigned char) SclF1);
	_outp (Adr+1,(unsigned char)(SclF1>>8));
#else            
	OutVals[2] = (unsigned char) ScF1;
	OutVals[3] = (unsigned char)(ScF1 >>8);
	OutVals[0] = (unsigned char) SclF1;
	OutVals[1] = (unsigned char)(SclF1>>8);
#endif 		//sim
	}
	END_TRY              
}			

extern "C" void    FAR PASCAL _export 
SetScf2(short Adr, short ScF2){
	TRY
	{                                
#if	 !sim
	_outp (Adr+6,(unsigned char) ScF2);
	_outp (Adr+7,(unsigned char)(ScF2 >>8));
	_outp (Adr	,(unsigned char) SclF2);
	_outp (Adr+1,(unsigned char)(SclF2>>8));
#else            
	OutVals[6] = (unsigned char) ScF2;
	OutVals[7] = (unsigned char)(ScF2 >>8);
	OutVals[0] = (unsigned char) SclF2;
	OutVals[1] = (unsigned char)(SclF2>>8);
#endif 		//sim
	}
	END_TRY
}

extern "C" void    FAR PASCAL _export 
SetScf3(short Adr, short ScF3){
	TRY
	{                                
#if	 !sim
	_outp (Adr+10,(unsigned char) ScF3);
	_outp (Adr+11,(unsigned char)(ScF3>>8));
	_outp (Adr	 ,(unsigned char) SclF3);
	_outp (Adr+1 ,(unsigned char)(SclF3>>8));
#else            
	OutVals[10] = (unsigned char) ScF3;
	OutVals[11] = (unsigned char)(ScF3 >>8);
	OutVals[0]  = (unsigned char) SclF3;
	OutVals[1]  = (unsigned char)(SclF3>>8);
#endif 		//sim
	}
	END_TRY
}
extern "C" void    FAR PASCAL _export 
SetScf4(short Adr, short ScF4){
	TRY
	{                                
#if	 !sim
	_outp (Adr+14,(unsigned char) ScF4);
	_outp (Adr+15,(unsigned char)(ScF4 >>8));
	_outp (Adr	 ,(unsigned char) SclF4);
	_outp (Adr+1 ,(unsigned char)(SclF4>>8));
#else            
	OutVals[14] = (unsigned char)ScF4;
	OutVals[15] = (unsigned char)(ScF4 >>8);
	OutVals[0]= (unsigned char)SclF4;
	OutVals[1]= (unsigned char)(SclF4>> 8);
#endif 		//sim
	}
	END_TRY
}
         
extern "C" void    FAR PASCAL _export 
SetVal1(short Adr, short Val1){
	TRY
	{                                
#if	 !sim
	_outp (Adr+4,(unsigned char)  Val1);
	_outp (Adr+5,(unsigned char)( Val1 >> 8));
	_outp (Adr	,(unsigned char) PVal1);
	_outp (Adr+1,(unsigned char)(PVal1 >> 8));
#else            
	OutVals[4] = (unsigned char)  Val1;
	OutVals[5] = (unsigned char)( Val1 >> 8);
	OutVals[0] = (unsigned char) PVal1;
	OutVals[1] = (unsigned char)(PVal1 >> 8);
#endif 		//sim
	}
	END_TRY
}
extern "C" void    FAR PASCAL _export 
SetVal2(short Adr, short Val2){
	TRY
	{                                
#if	 !sim
	_outp (Adr+8,(unsigned char)  Val2);
	_outp (Adr+9,(unsigned char)( Val2 >> 8));
	_outp (Adr	,(unsigned char) PVal2);
	_outp (Adr+1,(unsigned char)(PVal2 >> 8));
#else            
	OutVals[8] = (unsigned char)  Val2;
	OutVals[9] = (unsigned char)( Val2 >> 8);
	OutVals[0] = (unsigned char) PVal2;
	OutVals[1] = (unsigned char)(PVal2 >> 8);
#endif 		//sim
	}
	END_TRY
}
extern "C" void    FAR PASCAL _export 
SetVal3(short Adr, short Val3){
	TRY
	{                                
#if	 !sim
	_outp (Adr+12,(unsigned char)  Val3);
	_outp (Adr+13,(unsigned char)( Val3 >> 8));
	_outp (Adr	 ,(unsigned char) PVal3);
	_outp (Adr+1 ,(unsigned char)(PVal3 >> 8));
#else            
	OutVals[12] = (unsigned char)  Val3;
	OutVals[13] = (unsigned char)( Val3 >> 8);
	OutVals[0]  = (unsigned char) PVal3;
	OutVals[1]  = (unsigned char)(PVal3 >> 8);
#endif 		//sim
	}
	END_TRY
}
extern "C" void    FAR PASCAL _export 
SetVal4(short Adr, short Val4){
	TRY
	{                                
#if	 !sim
	_outp (Adr+16,(unsigned char)  Val4);
	_outp (Adr+17,(unsigned char)( Val4 >> 8));
	_outp (Adr	 ,(unsigned char) PVal4);
	_outp (Adr+1 ,(unsigned char)(PVal4 >> 8));
#else            
	OutVals[16] = (unsigned char)  Val4;
	OutVals[17] = (unsigned char)( Val4 >> 8);
	OutVals[0]  = (unsigned char) PVal4;
	OutVals[1]  = (unsigned char)(PVal4 >> 8);
#endif 		//sim
	}
	END_TRY
}
         
extern "C" void FAR PASCAL _export 
Preset1(short Adr){
	TRY
	{                                
#if !sim
	_outp	(Adr	,(unsigned char)  Prst1);
	_outp	(Adr+1	,(unsigned char) (Prst1 >> 8));
#else   //sim
	OutVals[0]= (unsigned char) Prst1;
	OutVals[1]= (unsigned char)(Prst1>> 8);
#endif
	}
	END_TRY
}
extern "C" void    FAR PASCAL _export 
Preset2(short Adr){
	TRY
	{                                
#if !sim
	_outp	(Adr	,(unsigned char)  Prst2);
	_outp	(Adr+1	,(unsigned char) (Prst2>> 8));
#else   //sim
	OutVals[0]= (unsigned char) Prst2;
	OutVals[1]= (unsigned char)(Prst2>> 8);
#endif
	}
	END_TRY
}

extern "C" void    FAR PASCAL _export 
Preset3(short Adr){
	TRY
	{                                
#if !sim
	_outp	(Adr	,(unsigned char)  Prst3);
	_outp	(Adr+1	,(unsigned char) (Prst3>> 8));
#else   //sim
	OutVals[0]= (unsigned char) Prst3;
	OutVals[1]= (unsigned char)(Prst3>> 8);
#endif
	}
	END_TRY
}

extern "C" void    FAR PASCAL _export 
Preset4(short Adr){
	TRY
	{                                
#if !sim
	_outp	(Adr	,(unsigned char)  Prst4);
	_outp	(Adr+1	,(unsigned char) (Prst4>> 8));
#else   //sim
	OutVals[0]= (unsigned char) Prst4;
	OutVals[1]= (unsigned char)(Prst4>> 8);
#endif
	}
	END_TRY
}
                  
extern "C" void FAR PASCAL _export 
SeTacho(short Adr, short Tach){
	TRY
	{                                
#if !sim 
   if (Tach) {
	_outp	(Adr	,(unsigned char)((RspTm|SetTa) % 256));
	_outp	(Adr+1	,(unsigned char)((RspTm|SetTa) >>  8));
   } 	
   else	  {
	_outp	(Adr	,(unsigned char) (SetTa));
	_outp	(Adr+1	,(unsigned char) (SetTa>>8));
   }
#else   //sim
	OutVals[0]= (unsigned char) (Tach|SetTa);
	OutVals[1]= (unsigned char)((Tach|SetTa)>> 8);
#endif	//sim	
	}
	END_TRY
}

extern "C" void FAR PASCAL _export 
ClearEr(short Adr){
	TRY
	{                                
#if !sim
	_outp	(Adr	,(unsigned char) ClErr);
	_outp	(Adr+1	,(unsigned char)(ClErr>> 8));
	
#else   //sim
	OutVals[0]= (unsigned char) ClErr;
	OutVals[1]= (unsigned char)(ClErr>> 8);
#endif
	}
	END_TRY
}
                
extern "C" void FAR PASCAL _export 
SetPhSh(short Adr, short Val){
	TRY
	{	        
	_outp	(Adr+2	,(unsigned char) Val);
	_outp	(Adr+3	,(unsigned char)(Val>> 8));
    _outp	(Adr	,(unsigned char)((Trsmt|RspTm) % 256));
	_outp	(Adr+1	,(unsigned char)((Trsmt|RspTm)>> 8));
	
	}
	END_TRY
}
                
extern "C" void FAR PASCAL _export 
SetAmpl(short Adr, short Val){
	TRY
	{                                
	_outp	(Adr+2	,(unsigned char) Val);
	_outp	(Adr+3	,(unsigned char)(Val>> 8));
	_outp	(Adr	,(unsigned char) Trsmt);
	_outp	(Adr+1	,(unsigned char)(Trsmt>> 8));
	
	}
	END_TRY
}

extern "C" void FAR PASCAL _export 
SetZero(short Adr){
	TRY
	{
#if !sim
	_outp	(Adr	,(unsigned char) 0);
	_outp	(Adr+1	,(unsigned char) 0);
#else   //sim
	OutVals[0]= (unsigned char) 0;
	OutVals[1]= (unsigned char) 0;
#endif
	}
	END_TRY
}	
                
extern "C" short    FAR PASCAL _export 
GetPos1(short Adr, short Cnt){
	CrslvApp::GetInp(Adr,Cnt);
	return  Input[1];
}
extern "C" short    FAR PASCAL _export 
GetPos2(short Adr, short Cnt){
	CrslvApp::GetInp(Adr,Cnt);
	return  Input[3];
}
extern "C" short    FAR PASCAL _export 
GetPos3(short Adr, short Cnt){
	CrslvApp::GetInp(Adr,Cnt);
	return  Input[5];
}
extern "C" short    FAR PASCAL _export 
GetPos4(short Adr, short Cnt){
	CrslvApp::GetInp(Adr,Cnt);
	return  Input[7];
}
         
extern "C" short    FAR PASCAL _export 
GetVel1(short Adr, short Cnt){
	CrslvApp::GetInp(Adr,Cnt);
	return  Input[2];
}
extern "C" short    FAR PASCAL _export 
GetVel2(short Adr, short Cnt){
	CrslvApp::GetInp(Adr,Cnt);
	return  Input[4];
}
extern "C" short    FAR PASCAL _export 
GetVel3(short Adr, short Cnt){
	CrslvApp::GetInp(Adr,Cnt);
	return  Input[6];
}
extern "C" short    FAR PASCAL _export 
GetVel4(short Adr, short Cnt){
	CrslvApp::GetInp(Adr,Cnt);
	return  Input[8];
}
                                                                                  
extern "C" short    FAR PASCAL _export 
GetFlgs(short Adr, short Cnt){
	CrslvApp::GetInp(Adr,Cnt);
	return	Input[0];
}
extern "C" long    FAR PASCAL _export 
GeTicks(){
	return	GetTickCount();
}
